(define-cpp-type ostream* static
  id: ostream*
  class: ostream
  cpp-type-dcl: "ostream *%s"
  cast: "((ostream *)(%s))"
  callback-res-converter: "(ostream *)(%s)"
  c-callback-arg-type: "void *%s")
(define-cpp-type ios* static
  id: ios*
  class: ios
  cpp-type-dcl: "ios *%s"
  cast: "((ios *)(%s))"
  callback-res-converter: "(ios *)(%s)"
  c-callback-arg-type: "void *%s")
(define-cpp-type ios::seek_dir enum
  cpp-arg-type: "((ios::seek_dir)(%s))"
  id: ios::seek_dir)
(define-cpp-type char* internal.char* cpp-type-dcl: "char *%s")
(define-cpp-type istream& static
  id: istream*
  class: istream
  cpp-type-dcl: "istream &%s"
  cast: "((istream &)(%s))"
  arg-type: "istream *%s"
  arg-converter: "*(%s)"
  res-type: "istream *%s"
  res-converter: "&%s"
  callback-arg-converter: "&%s"
  callback-res-converter: "*(istream *)(%s)"
  c-callback-arg-type: "void *%s")
(define-cpp-type unsigned-char* other-proxy
  cpp-type-dcl: "unsigned char *%s"
  id: unsigned-char*
  cast: "((unsigned char *)(%s))"
  c-callback-arg-type: "void *%s")
(define-cpp-type short& other-proxy
  cpp-type-dcl: "short &%s"
  id: short*
  cast: "((short &)(%s))"
  arg-type: "short *%s"
  arg-converter: "*(%s)"
  res-type: "short *%s"
  res-converter: "&%s"
  callback-arg-converter: "&%s"
  callback-res-converter: "*(short *)(%s)"
  c-callback-arg-type: "void *%s")
(define-cpp-type unsigned-short& other-proxy
  cpp-type-dcl: "unsigned short &%s"
  id: unsigned-short*
  cast: "((unsigned short &)(%s))"
  arg-type: "unsigned short *%s"
  arg-converter: "*(%s)"
  res-type: "unsigned short *%s"
  res-converter: "&%s"
  callback-arg-converter: "&%s"
  callback-res-converter: "*(unsigned short *)(%s)"
  c-callback-arg-type: "void *%s")
(define-cpp-type int& other-proxy
  cpp-type-dcl: "int &%s"
  id: int*
  cast: "((int &)(%s))"
  arg-type: "int *%s"
  arg-converter: "*(%s)"
  res-type: "int *%s"
  res-converter: "&%s"
  callback-arg-converter: "&%s"
  callback-res-converter: "*(int *)(%s)"
  c-callback-arg-type: "void *%s")
(define-cpp-type unsigned-int& other-proxy
  cpp-type-dcl: "unsigned int &%s"
  id: unsigned-int*
  cast: "((unsigned int &)(%s))"
  arg-type: "unsigned int *%s"
  arg-converter: "*(%s)"
  res-type: "unsigned int *%s"
  res-converter: "&%s"
  callback-arg-converter: "&%s"
  callback-res-converter: "*(unsigned int *)(%s)"
  c-callback-arg-type: "void *%s")
(define-cpp-type long& other-proxy
  cpp-type-dcl: "long &%s"
  id: long*
  cast: "((long &)(%s))"
  arg-type: "long *%s"
  arg-converter: "*(%s)"
  res-type: "long *%s"
  res-converter: "&%s"
  callback-arg-converter: "&%s"
  callback-res-converter: "*(long *)(%s)"
  c-callback-arg-type: "void *%s")
(define-cpp-type unsigned-long& other-proxy
  cpp-type-dcl: "unsigned long &%s"
  id: unsigned-long*
  cast: "((unsigned long &)(%s))"
  arg-type: "unsigned long *%s"
  arg-converter: "*(%s)"
  res-type: "unsigned long *%s"
  res-converter: "&%s"
  callback-arg-converter: "&%s"
  callback-res-converter: "*(unsigned long *)(%s)"
  c-callback-arg-type: "void *%s")
(define-cpp-type float& other-proxy
  cpp-type-dcl: "float &%s"
  id: float*
  cast: "((float &)(%s))"
  arg-type: "float *%s"
  arg-converter: "*(%s)"
  res-type: "float *%s"
  res-converter: "&%s"
  callback-arg-converter: "&%s"
  callback-res-converter: "*(float *)(%s)"
  c-callback-arg-type: "void *%s")
(define-cpp-type double& other-proxy
  cpp-type-dcl: "double &%s"
  id: double*
  cast: "((double &)(%s))"
  arg-type: "double *%s"
  arg-converter: "*(%s)"
  res-type: "double *%s"
  res-converter: "&%s"
  callback-arg-converter: "&%s"
  callback-res-converter: "*(double *)(%s)"
  c-callback-arg-type: "void *%s")
(define-cpp-type streampos long
  cpp-type-dcl: "streampos %s"
  cpp-arg-type: "((streampos)(%s))"
  cast: "((streampos)(%s))")
(define-cpp-type streamoff long
  cpp-type-dcl: "streamoff %s"
  cpp-arg-type: "((streamoff)(%s))"
  cast: "((streamoff)(%s))")
(define-cpp-type istream* static
  id: istream*
  class: istream
  cpp-type-dcl: "istream *%s"
  cast: "((istream *)(%s))"
  callback-res-converter: "(istream *)(%s)"
  c-callback-arg-type: "void *%s")
(define-cpp-type const-char* internal.char* cpp-type-dcl: "const char *%s")
(define-cpp-type ostream& static
  id: ostream*
  class: ostream
  cpp-type-dcl: "ostream &%s"
  cast: "((ostream &)(%s))"
  arg-type: "ostream *%s"
  arg-converter: "*(%s)"
  res-type: "ostream *%s"
  res-converter: "&%s"
  callback-arg-converter: "&%s"
  callback-res-converter: "*(ostream *)(%s)"
  c-callback-arg-type: "void *%s")
(define-cpp-type const-void* internal.void* cpp-type-dcl: "const void *%s")
(define-cpp-type streambuf* static
  id: streambuf*
  class: streambuf
  cpp-type-dcl: "streambuf *%s"
  cast: "((streambuf *)(%s))"
  callback-res-converter: "(streambuf *)(%s)"
  c-callback-arg-type: "void *%s")
(define-cpp-type istrstream* static
  id: istrstream*
  class: istrstream
  cpp-type-dcl: "istrstream *%s"
  cast: "((istrstream *)(%s))"
  callback-res-converter: "(istrstream *)(%s)"
  c-callback-arg-type: "void *%s")
(define-cpp-type ostrstream* static
  id: ostrstream*
  class: ostrstream
  cpp-type-dcl: "ostrstream *%s"
  cast: "((ostrstream *)(%s))"
  callback-res-converter: "(ostrstream *)(%s)"
  c-callback-arg-type: "void *%s")
(define-cpp-type fstreambase* static
  id: fstreambase*
  class: fstreambase
  cpp-type-dcl: "fstreambase *%s"
  cast: "((fstreambase *)(%s))"
  callback-res-converter: "(fstreambase *)(%s)"
  c-callback-arg-type: "void *%s")
(define-cpp-type ifstream* static
  id: ifstream*
  class: ifstream
  cpp-type-dcl: "ifstream *%s"
  cast: "((ifstream *)(%s))"
  callback-res-converter: "(ifstream *)(%s)"
  c-callback-arg-type: "void *%s")
(define-cpp-type ofstream* static
  id: ofstream*
  class: ofstream
  cpp-type-dcl: "ofstream *%s"
  cast: "((ofstream *)(%s))"
  callback-res-converter: "(ofstream *)(%s)"
  c-callback-arg-type: "void *%s")
